arkdep/arkdep-build

189 lines
6.6 KiB
Text
Raw Normal View History

2023-06-21 18:36:52 +02:00
#!/usr/bin/env bash
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# Print manual if no parameters provided or invalid amount of parameters is provided
if [[ ! -n $1 || -n $2 ]]; then
cat <<- END
2023-09-21 21:51:57 +02:00
Usage: arkdep-build [variant]
2023-06-21 18:36:52 +02:00
Variants:
2023-08-14 08:53:26 +02:00
archlinux Plain Arch Linux TTY image
2023-06-21 18:36:52 +02:00
arkanelinux Arkane Linux GNOME image
Variants are loaded based on their directory names, the ones listed here
2023-08-14 08:35:35 +02:00
are included by default.
2023-08-14 08:50:48 +02:00
Variables:
2023-09-21 21:56:37 +02:00
ARKDEP_NO_TAR Do not create a compressed tarball, only create the images
ARKDEP_CUSTOM_NAME Define a custom image name
ARKDEP_OUTPUT_TARGET Overwrite location to which images will be written
2023-10-08 06:08:53 +02:00
ARKDEP_CONFIGS Define directory in which build will search for configuration files
2023-06-21 18:36:52 +02:00
END
exit 0
fi
## Common functions
#
# Cleanup and quit if error
cleanup_and_quit () {
# If any paramters are passed we will assume it to be an error
2023-06-22 02:27:51 +02:00
[[ -n $1 ]] && printf "\e[1;31m<#>\e[0m $*\e[0m\n" >&2
2023-06-21 18:36:52 +02:00
2023-09-10 08:26:43 +02:00
umount $workdir
2023-06-26 00:32:59 +02:00
btrfs property set -ts $workdir ro false
btrfs property set -ts $workdir/etc ro false
btrfs property set -ts $workdir/var ro false
2023-06-21 18:36:52 +02:00
# Remove temporary btrfs volumes
2023-08-13 06:13:19 +02:00
rm -rf $workdir/etc \
2023-06-26 00:32:59 +02:00
$workdir/var \
2023-08-13 06:13:19 +02:00
$workdir
2023-06-21 18:36:52 +02:00
# Quit program if argument provided to function
[[ -n $1 ]] && exit 1
# Otherwise just quit, there is no error
exit 0
}
## Set common variables
#
declare -r workdir='/var/tmp/rootfs'
2023-10-08 06:08:53 +02:00
[[ -v ARKDEP_CONFIGS ]] &&
declare -r configs_dir="$ARKDEP_CONFIGS" ||
declare -r configs_dir="$(readlink -m ./arkdep-build.d/)"
declare -r variant="$1"
declare -r type="$(cat $(readlink -m $configs_dir/$variant/type) 2> /dev/null || cleanup_and_quit 'Failed to get build type')"
[[ -v ARKDEP_OUTPUT_TARGET ]] &&
declare -r output_target="$ARKDEP_OUTPUT_TARGET" ||
declare -r output_target="$(pwd)/target/"
2023-08-11 08:04:36 +02:00
# Generate a 42 character long random string, used for generating psuedo-random
# image names
gen_random_string () {
if [[ -v ARKDEP_CUSTOM_NAME ]]; then
random=$ARKDEP_CUSTOM_NAME
else
random=$(openssl rand -hex 100 | head -c 42)
fi
2023-08-11 08:04:36 +02:00
printf "${random}\n"
}
2023-06-21 18:36:52 +02:00
## Error checking
#
# Quit if not root
[[ ! $EUID -eq 0 ]] &&
2023-06-22 02:27:51 +02:00
printf '\e[1;31m<#>\e[0m\e[1m This program has to be run as root\n\e[0m' &&
2023-06-21 18:36:52 +02:00
exit 1
# Check if all dependencies are installed, quit if not
for prog in btrfs pacstrap; do
if ! command -v $prog > /dev/null; then
2023-06-22 02:27:51 +02:00
printf "\e[1;31m<#>\e[0m\e[1m Failed to locate $prog, ensure it is installed\e[0m\n"
2023-06-21 18:36:52 +02:00
exit 1
fi
done
# Check if requested variant exists
2023-10-08 06:08:53 +02:00
[[ ! -d $configs_dir/$variant ]] &&
2023-06-22 02:27:51 +02:00
printf '\e[1;31m<#>\e[0m\e[1m The requested variant does not exist\e[0m\n' &&
2023-06-21 18:36:52 +02:00
exit 1
2023-06-22 01:53:19 +02:00
## Variants
#
2023-06-21 18:36:52 +02:00
# Build archlinux type image
2023-06-25 20:27:47 +02:00
if [[ $type == 'archlinux' ]]; then
2023-06-21 18:36:52 +02:00
# Ensure base.list exists, if not error and quit
2023-10-08 06:08:53 +02:00
if [[ ! -e $configs_dir/$variant/base.list ]]; then
2023-08-10 06:44:20 +02:00
printf "\e[1;31m<#>\e[0m\e[1m The required file 'base.list' is not preset in $(readlink -m $configs_dir/$variant)\e[0m\n" &&
2023-06-21 18:36:52 +02:00
exit 1
2023-08-10 06:44:20 +02:00
fi
2023-06-21 18:36:52 +02:00
2023-06-22 02:27:51 +02:00
printf '\e[1;34m-->\e[0m\e[1m Started Arch linux image build\e[0m\n'
2023-06-21 18:36:52 +02:00
# Create temporary Btrfs subvolume
2023-06-26 00:32:59 +02:00
printf "\e[1;34m-->\e[0m\e[1m Creating temporary Btrfs subvolumes at $(readlink -m $workdir)\e[0m\n"
2023-06-22 02:33:11 +02:00
btrfs subvolume create $workdir || cleanup_and_quit "Failed to create btrfs subvolume $(readlink -m $workdir)"
2023-06-26 00:32:59 +02:00
btrfs subvolume create $workdir/etc || cleanup_and_quit "Failed to create btrfs subvolume $(readlink -m $workdir/etc)"
btrfs subvolume create $workdir/var || cleanup_and_quit "Failed to create btrfs subvolume $(readlink -m $workdir/var)"
2023-06-21 18:36:52 +02:00
2023-09-10 08:26:43 +02:00
printf "\e[1;34m-->\e[0m\e[1m Creating bind mount at $(readlink -m $workdir)\e[0m\n"
mount --bind $workdir $workdir
2023-06-21 18:36:52 +02:00
# Read base package list and install base system
2023-10-08 06:08:53 +02:00
readarray base_packages < $configs_dir/$variant/base.list
2023-06-22 02:27:51 +02:00
printf "\e[1;34m-->\e[0m\e[1m Installing base packages\e[0m\n"
2023-06-21 18:36:52 +02:00
pacstrap $workdir ${base_packages[*]} || cleanup_and_quit 'Failed to install secondary package list'
2023-08-13 06:13:19 +02:00
# If overlay directory exists in variant copy it's contents to the temporary subvolume
2023-10-08 06:08:53 +02:00
if [[ -d $configs_dir/$variant/overlay ]]; then
cp -rv $configs_dir/$variant/overlay/* $workdir/
2023-08-13 06:13:19 +02:00
fi
2023-08-10 06:44:20 +02:00
2023-08-13 06:13:19 +02:00
# Read package list and install secondary system components, skip if not used
2023-10-08 06:08:53 +02:00
if [[ -e $configs_dir/$variant/package.list ]]; then
2023-09-19 00:23:53 +02:00
printf '\e[1;34m-->\e[0m\e[1m Installing secondary packages\e[0m\n'
2023-10-08 06:08:53 +02:00
readarray packages < $configs_dir/$variant/package.list
2023-06-21 18:36:52 +02:00
arch-chroot $workdir pacman -S --noconfirm ${packages[*]} || cleanup_and_quit 'Failed to install base packages'
fi
2023-08-09 08:09:20 +02:00
# Clear pacman cache
arch-chroot $workdir pacman --noconfirm -Scc
2023-06-21 18:36:52 +02:00
# Remove subvolumes created by systemd
[[ -d $workdir/var/lib/portables ]] &&
2023-09-16 18:04:30 +02:00
printf "\e[1;34m-->\e[0m\e[1m Removing systemd subvolume var/lib/portables\e[0m\n"
2023-06-21 18:36:52 +02:00
btrfs subvolume delete $workdir/var/lib/portables
[[ -d $workdir/var/lib/machines ]] &&
2023-09-16 18:04:30 +02:00
printf "\e[1;34m-->\e[0m\e[1m Removing systemd subvolume var/lib/machines\e[0m\n"
2023-06-21 18:36:52 +02:00
btrfs subvolume delete $workdir/var/lib/machines
2023-06-25 17:53:30 +02:00
# Clear pacman cache
2023-09-16 18:04:30 +02:00
printf "\e[1;34m-->\e[0m\e[1m Clearing pacman cache\e[0m\n"
2023-06-25 17:53:30 +02:00
rm -rf $workdir/var/cache/pacman/pkg/*
rm -rf $workdir/var/lib/pacman/local/*
2023-09-19 00:23:53 +02:00
# Make /usr/local symlink in var
printf "\e[1;34m-->\e[0m\e[1m Creating usrlocal symlink\e[0m\n"
mv $workdir/usr/local $workdir/var/usrlocal || cleanup_and_quit 'Failed to move usr/local to var/usrlocal'
ln -s /var/usrlocal $workdir/usr/local || cleanup_and_quit 'Failed to create usrlocal symlink'
2023-06-21 18:36:52 +02:00
# Make subvolume read-only
2023-06-26 00:32:59 +02:00
printf "\e[1;34m-->\e[0m\e[1m Adding read-only property to subvolumes\e[0m\n"
2023-09-19 00:23:53 +02:00
btrfs property set -ts $workdir ro true || cleanup_and_quit 'Failed to set root to read-only'
btrfs property set -ts $workdir/etc ro true || cleanup_and_quit 'Failed to set etc to read-only'
btrfs property set -ts $workdir/var ro true || cleanup_and_quit 'Failed to set var to read-only'
2023-06-21 18:36:52 +02:00
2023-08-11 08:04:36 +02:00
# Generate random name for new image
2023-09-19 00:23:53 +02:00
printf "\e[1;34m-->\e[0m\e[1m Generating psuedo-random image name\e[0m\n"
2023-08-11 08:04:36 +02:00
declare -r image_name=$(gen_random_string)
printf "$image_name\n"
2023-08-11 08:04:36 +02:00
# Create dir for storing the images
mkdir -vp $(readlink -m $output_target/$image_name)
2023-06-21 18:36:52 +02:00
# Write subvolume to image
2023-09-19 00:23:53 +02:00
printf "\e[1;34m-->\e[0m\e[1m Creating images\e[0m\n"
2023-08-13 06:13:19 +02:00
btrfs send -f $output_target/$image_name/$image_name-rootfs.img $workdir
btrfs send -f $output_target/$image_name/$image_name-etc.img $workdir/etc
btrfs send -f $output_target/$image_name/$image_name-var.img $workdir/var
2023-09-21 21:56:37 +02:00
if [[ ! -v ARKDEP_NO_TAR ]]; then
2023-09-19 00:23:53 +02:00
printf "\e[1;34m-->\e[0m\e[1m Compressing images\e[0m\n"
2023-08-14 19:08:51 +02:00
tar -cv -I 'zstd -12 -T0 ' -f $output_target/$image_name.tar.zst -C $output_target/$image_name .
2023-08-14 08:50:48 +02:00
fi
2023-06-21 18:36:52 +02:00
cleanup_and_quit
2023-08-11 08:04:36 +02:00
2023-09-16 18:04:30 +02:00
fi